<?php
/**
 * MIT License
 *
 * Copyright (c) 2017 Pentagonal Development
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON INFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 */

namespace Apatis\Config;

use function Apatis\Config;

/**
 * @param array $config
 *
 * @return ConfigInterface
 */
function FromArray(array $config)
{
    return Factory::fromArray($config);
}

/**
 * @param string $file
 *
 * @return ConfigInterface
 */
function FromFile(string $file) : ConfigInterface
{
    return Factory::fromFile($file);
}

/**
 * @param mixed $name
 * @param mixed $value
 */
function Set($name, $value)
{
    Config()->set($name, $value);
}

/**
 * @param mixed $name
 * @param null $default
 *
 * @return mixed
 */
function Get($name, $default = null)
{
    return Config()->get($name, $default);
}

/**
 * @param ConfigInterface $config
 *
 * @return ConfigInterface
 */
function Merge(ConfigInterface $config) : ConfigInterface
{
    return Config($config);
}

/**
 * @param array $values
 *
 * @return ConfigInterface
 */
function Replace(array $values) : ConfigInterface
{
    return Config($values);
}
